<template>
  <div class="row">
    <div class="col-12">
      <ul class="pagination pagination-rounded justify-content-end mb-3">
        <li class="page-item">
          <a class="page-link" :href="'?page=1'" aria-label="Previous" @click="goto(1)">
            <span aria-hidden="true">«</span>
            <span class="sr-only">Previous</span>
          </a>
        </li>
          <li v-for="pageList in getPaginationList()" class="page-item" :class="{'active': activePage == pageList}"><a class="page-link" :href="'?page='+pageList" @click="goto(pageList)">{{pageList}}</a></li>
        <li class="page-item">
          <a class="page-link" :href="'?page='+pageCount" aria-label="Next" @click="goto(pageCount)">
            <span aria-hidden="true">»</span>
            <span class="sr-only">Next</span>
          </a>
        </li>
      </ul>
    </div> <!-- end col-->
  </div>
  <!-- end row-->
</template>

<script>
var VueScrollTo = require('vue-scrollto');
export default {
  name: "Pagination",
  props: {
    pageCount: {
      type: Number,
      required: true
    },
    route: {
      type: Object,
      required: true
    },
  },
  methods: {
    goto(page) {
      this.$emit('input', page);
      VueScrollTo.scrollTo('.page-title-box');
    },
    getPaginationList(){
      let pagesList = [];
      let pagesListLength;
      if(this.pageCount < 5){
        pagesListLength = this.pageCount;
      }else{
        pagesListLength = 5;
      }
      if(this.activePage <= 3){
        for (let i = 1; i <= pagesListLength; i++) {
          pagesList.push(i);
        }
      }else if(this.activePage >= (this.pageCount - 2) || this.activePage > this.pageCount){
        let start = this.pageCount - 4;
        for (let i = start; i <= this.pageCount; i++) {
          pagesList.push(i);
        }
      }else{
        let start = +this.activePage - 2;
        let end = +this.activePage + 2;
        for (let i = start; i <= end; i++) {
          pagesList.push(i);
        }
      }
      return pagesList;
    }
  },
  computed: {
    activePage: function () {
      if(this.route.query.page > this.pageCount)
        return this.pageCount;

      return this.route.query.page || 1
    }
  }
}
</script>

<style scoped>

</style>
